
function OneManArmy:StartActivity()
	self.DumWeps = {"Blaster", "Nailgun", "Sniper Rifle", "Grenade Launcher", "Repeater", "Nailer Cannon"}
	
	self.RonWeps = {"Bazooka", "YAK47", "YAK4700", "TommyGun", "Uzi", "M16", "Spaz12", "Spaz1200",
									"Rifle Long", "Desert Eagle", "Glock", "HAK 20", "Luger", "Peacemaker", "Pumpgun"}
	
	self.CoaWeps = {"Sniper Rifle", "Grenade Launcher", "Heavy Sniper Rifle", "Assault Rifle",
									"Gatling Gun", "Napalm Flamer", "Spike Launcher", "Flak Cannon", "Compact Assault Rifle",
									"Shotgun", "Auto Shotgun", "Mauler Shotgun", "Auto Cannon", "Revolver Cannon",
									"Rocket Launcher", "Homing Missile Launcher"}
	
	self.WList = {}
	
	self.AList = {"Ronin/Mia", "Ronin/Dafred", "Ronin/Dimitri", "Ronin/Gordon", "Ronin/Brutus", "Ronin/Sandra", "Coalition/Soldier Light", "Coalition/Soldier Heavy", 
								"Dummy/Dummy", "Base/Robot 1", "Base/Robot 2", "Browncoats/Browncoat Light", "Browncoats/Browncoat Heavy"}	--"Independent/Independent"
	
	for k,Val in pairs(self.DumWeps) do table.insert(self.WList, "Dummy/"..Val) end
	for k,Val in pairs(self.RonWeps) do table.insert(self.WList, "Ronin/"..Val) end
	for k,Val in pairs(self.CoaWeps) do table.insert(self.WList, "Coalition/"..Val) end
	
	-- Check if we already have a brain assigned
	if not self:GetPlayerBrain(Activity.PLAYER_1) then
		local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(Activity.PLAYER_1))
		-- If we can't find an unassigned brain in the scene to give the player, then force to go into editing mode to place one
		if not foundBrain then
			foundBrain = CreateAHuman("Soldier Heavy")			
			foundBrain:AddInventoryItem(CreateHDFirearm("Coalition/" .. self.CoaWeps[math.random(1,#self.CoaWeps)]))
			foundBrain:AddInventoryItem(CreateHDFirearm("Coalition/Heavy Pistol"))
			foundBrain:AddInventoryItem(CreateTDExplosive("Coalition/Grenade"))
			foundBrain:AddInventoryItem(CreateTDExplosive("Coalition/Grenade"))
			foundBrain.Pos = SceneMan:MovePointToGround(Vector(math.random(0, SceneMan.SceneWidth), 0), 0, 0) + Vector(0, -50)
			foundBrain.Team = self:GetTeamOfPlayer(Activity.PLAYER_1)
			MovableMan:AddActor(foundBrain)
			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(foundBrain, Activity.PLAYER_1)
			self:SwitchToActor(foundBrain, Activity.PLAYER_1, self:GetTeamOfPlayer(Activity.PLAYER_1))
			self:SetLandingZone(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
		else
			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(foundBrain, Activity.PLAYER_1)
			self:SwitchToActor(foundBrain, Activity.PLAYER_1, self:GetTeamOfPlayer(Activity.PLAYER_1))
			self:SetLandingZone(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
		end
	end
	
	ActivityMan:GetActivity():SetTeamFunds(0,0)
	
	self.TimeLeft = 0
	self.StartTimer = Timer()
	self.ESpawnTimer = Timer()
	self.SurvivalTimer = Timer()
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1")
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ All")
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.TimeLimit = 1.5*60*1000
		self.timeDisplay = "one minute and thirty seconds"
		self.BaseSpawnTime = 6000
		self.RandomSpawnTime = 8000
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.TimeLimit = 2*60*1000
		self.timeDisplay = "two minutes"
		self.BaseSpawnTime = 5500
		self.RandomSpawnTime = 7000
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.TimeLimit = 3*60*1000
		self.timeDisplay = "three minutes"
		self.BaseSpawnTime = 5000
		self.RandomSpawnTime = 6000
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.TimeLimit = 4*60*1000
		self.timeDisplay = "four minutes"
		self.BaseSpawnTime = 4500
		self.RandomSpawnTime = 5000
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.TimeLimit = 5*60*1000
		self.timeDisplay = "five minutes"
		self.BaseSpawnTime = 4000
		self.RandomSpawnTime = 4500
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.TimeLimit = 7*60*1000
		self.timeDisplay = "seven minutes"
		self.BaseSpawnTime = 3500
		self.RandomSpawnTime = 4000
	end
	
	collectgarbage("collect")
end

function OneManArmy:UpdateActivity()
	if self.ActivityState ~= Activity.OVER then
		ActivityMan:GetActivity():SetTeamFunds(0,0)
		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				--Display messages
				if self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText(math.floor(self.SurvivalTimer:LeftTillSimMS(self.TimeLimit) / 1000) .. " seconds left", player, 0, 1000, false)
				else
					FrameMan:SetScreenText("Survive for " .. self.timeDisplay .. "!", Activity.PLAYER_1, 333, 5000, true)
				end
			
				-- The current player's team
				local team = self:GetTeamOfPlayer(player)
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player)
					self:ResetMessageTimer(player)
					FrameMan:ClearScreenText(player)
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false)
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team)
						ActivityMan:EndActivity()
					end
				end
				
				--Check if the player has won
				if self.SurvivalTimer:IsPastSimMS(self.TimeLimit) then
					self:ResetMessageTimer(player)
					FrameMan:ClearScreenText(player)
					FrameMan:SetScreenText("A winner is you!", player, 333, -1, false)
					
					self.WinnerTeam = Activity.TEAM_1
					
					--Kill all enemies
					for actor in MovableMan.Actors do
						if actor.Team ~= self.WinnerTeam then
							actor.Health = 0
						end
					end

					ActivityMan:EndActivity()
				end
			end
		end

		--Spawn the AI
		if self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
			local Actors = {}
			local Target = self:GetPlayerBrain(0)
			local Craft, maxCargo
			
			if not MovableMan:IsActor(Target) then
				Target = nil
			end
			
			local z = math.random()
			if z > 0.97 then
				maxCargo = 1
				Craft = CreateACRocket("Drop Crate","Dummy.rte")
				Craft.Vel.Y = 15
			elseif z > 0.87 then
				maxCargo = 1
				Craft = CreateACRocket("Rocklet Mod 0","Safer Craft.rte")
				if not Craft then
					Craft = CreateACRocket("Rocklet","Dummy.rte")
				end
				Craft.Vel.Y = 5
			elseif z > 0.67 then
				maxCargo = math.random(2,4)
				Craft = CreateACDropShip("Dummy Drop Ship Mod 0","Safer Craft.rte")
				if not Craft then
					Craft = CreateACDropShip("Drop Ship","Dummy.rte")
				end
				Craft.Vel.Y = 10
			elseif z > 0.47 then
				maxCargo = math.random(2,4)
				Craft = CreateACDropShip("Drop Ship MK1 Mod 0","Safer Craft.rte")
				--print(Craft.PresetName .. " script reload: " .. Craft:ReloadScripts())
				if not Craft then
					Craft = CreateACDropShip("Drop Ship MK1","Base.rte")
				end
				Craft.Vel.Y = 10
			elseif z > 0.20 then
				maxCargo = math.random(1,2)
				Craft = CreateACRocket("Rocket MK2 Mod 0","Safer Craft.rte")
				if not Craft then
					Craft = CreateACRocket("Rocket MK2","Base.rte")
				end
				Craft.Vel.Y = 5
			else
				maxCargo = math.random(1,2)
				Craft = CreateACRocket("Rocket MK1 Mod 0","Safer Craft.rte")
				if not Craft then
					Craft = CreateACRocket("Rocket MK1","Base.rte")
				end
			end
			
			for i = 1, maxCargo do
				local y = math.random()
				if y > 0.05 then
					Actors[i] = CreateAHuman(self.AList[math.random(#self.AList)])
					Actors[i]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(1,#self.WList)]))
					
					if PosRand() < 0.05 then
						Actors[i]:AddInventoryItem(CreateHDFirearm("Base/Light Digger"))
					elseif PosRand() < 0.75 then
						Actors[i]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(1,#self.WList)]))
					end
				else
					Actors[i] = CreateACrab("Dummy/Dreadnought")
				end
				
				Actors[i].Team = Activity.TEAM_2
				
				y = PosRand()
				if y < 0.2 and Target then
					Actors[i].AIMode = Actor.AIMODE_GOTO
					Actors[i]:AddAIMOWaypoint(Target)
				elseif y < 0.8 and Target then
					Actors[i].AIMode = Actor.AIMODE_GOTO
					Actors[i]:AddAISceneWaypoint(Target.Pos)
				else
					Actors[i].AIMode = Actor.AIMODE_BRAINHUNT
				end
			end
			
			for _,Act in pairs(Actors) do
				Craft:AddInventoryItem(Act)
			end
			
			Craft.Team = Activity.TEAM_2
			if PosRand() > 0.5 then
				Craft.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50)
			else
				if PosRand() > 0.5 then
					Craft.Pos = Vector(Target.Pos.X + RangeRand(250,600),-50)
				else
					Craft.Pos = Vector(Target.Pos.X - RangeRand(250,600),-50)
				end
			end
			
			MovableMan:AddActor(Craft)
			self.ESpawnTimer:Reset()
			self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime)
		end
	end
end